package com.datau.mdm.service;

import com.datau.mdm.dto.MdmInfoDataSourceInterfaceProjectDTO;
import com.datau.mdm.util.R;

import java.util.List;

public interface InterfaceProjectService  {

    /**
     * 数据中心接口数据源管理数据源信息接口查询（分页）
     * @param projectName
     * @param sort
     * @param order
     * @param page
     * @param pageSize
     * @return
     * @throws Exception
     */
    R<List<MdmInfoDataSourceInterfaceProjectDTO>> listInterfaceProject(String projectName, String sort, String order,
                                                                    Integer page, Integer pageSize) throws Exception;

    /**
     * 数据中心接口数据源管理数据源信息接口新增
     * @param mdmInfoDataSourceInterfaceProjectDTO
     */
    void addInterfaceProject(MdmInfoDataSourceInterfaceProjectDTO mdmInfoDataSourceInterfaceProjectDTO);

    /**
     * 数据中心接口数据源管理数据源信息接口修改
     * @param mdmInfoDataSourceInterfaceProjectDTO
     */
    void updateInterfaceProjectById(MdmInfoDataSourceInterfaceProjectDTO mdmInfoDataSourceInterfaceProjectDTO);

    /**
     * 数据中心接口数据源管理数据源信息接口删除
     * @param projectId
     */
    void deleteInterfaceProject(String projectId);

    MdmInfoDataSourceInterfaceProjectDTO getInterfaceProjectById(String projectId);
}
