package com.datau.kpim;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import springfox.documentation.swagger2.annotations.EnableSwagger2;
/* *
 * @Author jade
 * @Description  KPI配置管理主程序入口
 * @Date 2019/2/20
**/
@EnableSwagger2
@MapperScan("com.datau.kpim.mapper")
@EnableFeignClients
@EnableEurekaClient
@EnableTransactionManagement
@SpringBootApplication
public class KpimApplication{

	public static void main(String[] args) {
		SpringApplication.run(KpimApplication.class, args);
	}

}
