package com.datau.kpim.dto.topic;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @ClassName TopicDTO
 * @Desc 主题管理实体类
 * @Author jade
 * @Date 2019/2/19
 * @Version 1.0
 */
@Data
@ApiModel("主题管理模型")
public class TopicDTO implements Serializable {

    @ApiModelProperty("主键ID")
    private String id;

    @ApiModelProperty("主题编码")
    private String topicCode;

    @ApiModelProperty("主题名称")
    private String name;

    @ApiModelProperty("主题描述")
    private String description;

    @ApiModelProperty("主题级别")
    private Integer level;

    @ApiModelProperty("修改时间")
    private Date updateTime;

    @ApiModelProperty("修改人ID")
    private String updateUserId;

    @ApiModelProperty("修改人姓名")
    private String updateUserName;

    @ApiModelProperty("上级主题编码")
    @JsonProperty(value="pcode")
    private String parentTopicCode;

    @ApiModelProperty("上级主题")
    private String parentTopic;

    @ApiModelProperty("创建时间")
    private Date createTime;
}
