package com.datau.kpim.mapper.common;

import com.datau.kpim.dto.common.RuleTypeDTO;
import com.datau.kpim.dto.common.SignDTO;
import com.datau.kpim.dto.common.TypeDTO;
import com.datau.kpim.dto.common.UserDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/*
 * @Author jade
 * @Description 通用Mapper
 * @Date 2019/2/18
 */
public interface CommonMapper {
    /* *
     * @Author jade
     * @Description 配置类型列表查询
     * @Date 2019/2/20
     * @Param []
     * @return java.util.List<com.datau.kpim.dto.common.TypeDTO>
    **/
    List<TypeDTO> listTypes();

    /* *
     * @Author jade
     * @Description 符号列表查询
     * @Date 2019/2/20
     * @Param []
     * @return java.util.List<com.datau.kpim.dto.common.SignDTO>
    **/
    List<SignDTO> listSigns();

    /* *
     * @Author jade
     * @Description 规则类型列表查询
     * @Date 2019/2/21
     * @Param []
     * @return java.util.List<com.datau.kpim.dto.common.RuleTypeDTO>
    **/
    List<RuleTypeDTO> listRuleTypes(@Param("kpiType") Integer kpiType);

    /* *
     * @Author jade
     * @Description 查询普通管理员
     * @Date 2019/2/26
     * @Param [userType]
     * @return java.util.List<com.datau.kpim.dto.common.UserDTO>
    **/
    List<UserDTO> listAdministrativeUsers(@Param("userType") Integer userType);

}
