package com.datau.rpm.dto;

import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class ReportDTO {

	@ApiModelProperty("唯一标示")
	private String id;
	@ApiModelProperty("报表名称-前端规范")
	private String name;
	@ApiModelProperty("报表名称")
	private String reportName;
	@ApiModelProperty("报表描述")
	private String desc;
	@ApiModelProperty("报表类型：1-数据报表 2-文本 3-图片 4-视频")
	private Integer reportType;
	@ApiModelProperty("显示类型：1-整体展示 2-根据一个KPI如通道分组展示")
	private Integer showType;
	@ApiModelProperty("所属展示系统：1-自助报表 2-大屏")
	private Integer displaySystem;
	@ApiModelProperty("是否下钻")
	private Integer ifDrillDown;
	@ApiModelProperty("update_time")
	private Date updateTime;
	@ApiModelProperty("最近更新用户ID")
	private String updateUserId;
	@ApiModelProperty("启用状态：0-停用 1-启用 ")
	private Integer status;
	@ApiModelProperty("启用状态内容 ")
	private String statusValue;
	@ApiModelProperty("页面元素json")
	private String pageElements;
	@ApiModelProperty("报表层级：0-父级 1-子级")
	private Integer reportLevel;
	@ApiModelProperty("是否分页")
	private Integer ifPage;
	@ApiModelProperty("是否合计")
	private Integer ifTotal;
	@ApiModelProperty("布局：1-上图下表 2-上表下图")
	private Integer layoutId;
	@ApiModelProperty("颜色组ID")
	private Integer colorGroupId;
	@ApiModelProperty("查询生sql")
	private String sqlSelect;
	@ApiModelProperty("当前步骤：1-基本信息配置 2-选择KPI 3-查询条件配置 4-报表关系配置 5-图表配置 6-效果预览")
	private Integer currentStep;
	@ApiModelProperty("是否完成")
	private Integer ifFinish;
	@ApiModelProperty("最后修改人名称")
	private String updateUserName;
	@ApiModelProperty("报表类型内容")
	private String reportTypeValue;

	@ApiModelProperty("报表层级内容")
	private String reportLevelValue;
	@ApiModelProperty("展示类型内容")
	private String showTypeValue;
	@ApiModelProperty("是否成功内容")
	private String ifFinishValue;

	@ApiModelProperty("DML")
	private String DML;
	@ApiModelProperty("图表类型")
	private Integer chartType;
	@ApiModelProperty("图表分类code")
	private String chartClassCode;
	@ApiModelProperty("数据库id")
	private String databaseId;
	@ApiModelProperty("数据表id")
	private String tableId;
	@ApiModelProperty("图表json串")
	private String chartJson;
	@ApiModelProperty("富文本文档，图表类型为：富文本")
	private String richText;
	@ApiModelProperty("文件路径，图表类型为：图片、视频")
	private String filePath;
	@ApiModelProperty("图表数据刷新时间,单位：秒")
	private String chartRefrech;
	@ApiModelProperty("数据来源，1:KPI 2:DML 3:接口")
	private Integer dataSource;

	@ApiModelProperty("是否需要外部传参数。1是  0否")
	private Integer ifOutsideParam;
	@ApiModelProperty("合计数据展示位置 1-数据下方 2 报表上方")
	private Integer totalShowType;

}
