package com.datau.rpm.dto.save;

import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @ClassName: SaveFiveDTO
 * @Description:报表配置保存模板
 * @author: Zhao You Kai
 * @date: Mar 8, 2019 3:06:54 PM
 */
@Data
public class SaveFiveDTO {
	@ApiModelProperty("报表ID")
	private String id;

	@ApiModelProperty("最近更新时间")
	private String updateTime;
	@ApiModelProperty("最近更新用户ID")
	private String updateUserId;
	@ApiModelProperty("启用状态：0-停用 1-启用 ")
	private Integer status;
	@ApiModelProperty("布局：1-上图下表 2-上表下图")
	private Integer layoutId;
	@ApiModelProperty("颜色组ID")
	private Integer colorGroupId;
	@ApiModelProperty("当前步骤：1-基本信息配置 2-选择KPI 3-查询条件配置 4-报表关系配置 5-图表配置 6-效果预览")
	private Integer currentStep;
	@ApiModelProperty("是否完成")
	private Integer ifFinish;
	@ApiModelProperty("分组字段KPI")
	private String groupKpi;
	@ApiModelProperty("饼状图kpi")
	private List<String> pieKpiIds;
	@ApiModelProperty("柱折混合图信息列表")
	private List<RpmInfoReportChartDTO> barAndLineCharts;
	@ApiModelProperty("是否饼图")
	private Integer ifPie;
	@ApiModelProperty("是否柱折混合图")
	private Integer ifBarAndLine;
	@ApiModelProperty("图表类型")
	private String chartType;
	@ApiModelProperty("图表json串")
	private String chartJson;
	@ApiModelProperty("富文本文档，图表类型为：富文本")
	private String richText;
	@ApiModelProperty("文件路径，图表类型为：图片、视频")
	private String filePath;

}
