package com.datau.rpm.dto.save;

import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @ClassName: SaveOneDTO
 * @Description:报表配置保存模板
 * @author: Zhao You Kai
 * @date: Mar 8, 2019 3:06:54 PM
 */
@Data
public class SaveOneDTO {
	@ApiModelProperty("报表ID")
	private String id;
	@ApiModelProperty("报表名称")
	private String reportName;
	@ApiModelProperty("报表类型：1-报表，2-富文本，3-图片，4-视频")
	private Integer reportType;
	@ApiModelProperty("显示类型：1-整体展示 2-根据一个KPI如通道分组展示")
	private Integer showType;
	@ApiModelProperty("所属展示系统：1-自助报表 2-大屏")
	private Integer displaySystem;
	@ApiModelProperty("最近更新时间")
	private String updateTime;
	@ApiModelProperty("最近更新用户ID")
	private String updateUserId;
	@ApiModelProperty("报表层级：0-父级 1-子级")
	private Integer reportLevel;
	@ApiModelProperty("当前步骤：1-基本信息配置 2-选择KPI 3-查询条件配置 4-报表关系配置 5-图表配置 6-效果预览")
	private Integer currentStep;
	@ApiModelProperty("启用状态：0-停用 1-启用 ")
	private Integer status;
	@ApiModelProperty("是否完成")
	private Integer ifFinish;
	@ApiModelProperty("菜单分类code")
	private String menuCode;

	@ApiModelProperty("图表类型")
	private Integer chartType;
	@ApiModelProperty("图表分类code")
	private String chartClassCode;
	@ApiModelProperty("图表数据刷新时间,单位：秒")
	private Integer chartRefrech;
	@ApiModelProperty("数据来源，1:KPI 2:DML 3:接口")
	private Integer dataSource;

}
