package com.datau.rpm.dto.save;

import com.fasterxml.jackson.annotation.JsonIgnore;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class SaveRportKpiDTO {
	@ApiModelProperty("报表ID")
	private String reportId;
	@ApiModelProperty("kpiId")
	private String kpiId;
	@ApiModelProperty("KPI重命名")
	private String rname;
	@ApiModelProperty("是否是时间查询")
	private Integer ifQueryTime;
	@ApiModelProperty("时间类型ID")
	private Integer timeTypeId;
	@ApiModelProperty("是否搜索条件")
	private Integer ifQuerySearch;
	@ApiModelProperty("搜索类型ID")
	private Integer searchTypeId;
	@ApiModelProperty("是否分组聚合查询")
	private Integer ifQueryGroupBy;
	@ApiModelProperty("是否排序")
	private Integer ifQueryOrderBy;
	@ApiModelProperty("是否标记颜色")
	private Integer ifQueryColor;
	@ApiModelProperty("标记颜色上限")
	private Double queryColorUpper;
	@ApiModelProperty("标记颜色下限")
	private Double queryColorLower;
	@ApiModelProperty("颜色ID")
	private Integer queryColorId;
	@ApiModelProperty("是否以分组展示报表")
	private Integer ifGroupShow;
	@ApiModelProperty("是否是下钻字段")
	private Integer ifDrillDown;
	@ApiModelProperty("子报表ID")
	private String subreportId;
	@ApiModelProperty("排序字段")
	private Integer sort;
	@ApiModelProperty("是否是时间字段")
	private Integer ifTime;
	@ApiModelProperty("是否是数字字段")
	private Integer ifNumber;
	@ApiModelProperty("是否是下钻关联条件")
	private Integer ifRelated;
	@ApiModelProperty("kpi-编码")
	private String kpiCode;
	@ApiModelProperty("聚合字段排序")
	private Integer queryGroupBySort;
	@ApiModelProperty("编辑状态：0不可编辑 1可编辑")
	protected Integer editStatus;
	@ApiModelProperty("查询字段排序")
	private Integer querySearchSort;

	@ApiModelProperty("时间类型KPI查询是否有默认值，1有默认值 0没有")
	@JsonIgnore
	private Integer timeQueryDefault;
	@ApiModelProperty("时间类型KPI默认偏移值，单位：天")
	private Integer timeDefaultOffset;

	@ApiModelProperty("时间类型KPI下钻是否有范围值，1有 0没有")
	@JsonIgnore
	private Integer timeRelatedRange;
	@ApiModelProperty("时间下钻是否以选择时间为基准：1是2否，以当前时间为基准")
	private Integer timeRelatedSelected;
	@ApiModelProperty("时间类型KPI范围值偏移值，单位：天")
	private Integer timeRangeOffset;

	@ApiModelProperty("主报表关联KPIID")
	private String relatedKpiId;
	@ApiModelProperty("主报表关联KPICODE")
	private String relatedKpiCode;
	@ApiModelProperty("下钻子报表关联KPIID")
	private String relatedSubKpiId;
	@ApiModelProperty("下钻子报表关联KPICODE")
	private String relatedSubKpiCode;

	@ApiModelProperty("是否是默认排序，1是  0否")
	private Integer ifQueryDefaultSort;

	@ApiModelProperty("默认排序，正序asc 倒叙desc")
	private String queryDefaultOrder;

	@ApiModelProperty("kpi是否合计，1是  0否")
	private Integer ifTotal;

	@ApiModelProperty("kpi合计展示顺序")
	private Integer totalShowSort;

	@ApiModelProperty("是否为可操作聚合 1是 2否")
	private Integer ifOperableGroupBy;
}
