package com.datau.rpm.dto.save;

import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @ClassName: SaveThreeDTO
 * @Description:报表配置保存模板
 * @author: Zhao You Kai
 * @date: Mar 8, 2019 3:06:54 PM
 */
@Data
public class SaveThreeDTO {
	@ApiModelProperty("报表ID")
	private String id;
	@ApiModelProperty("最近更新时间")
	private String updateTime;
	@ApiModelProperty("最近更新用户ID")
	private String updateUserId;
	@ApiModelProperty("启用状态：0-停用 1-启用 ")
	private Integer status;
	@ApiModelProperty("当前步骤：1-基本信息配置 2-选择KPI 3-查询条件配置 4-报表关系配置 5-图表配置 6-效果预览")
	private Integer currentStep;
	@ApiModelProperty("是否完成")
	private Integer ifFinish;
	@ApiModelProperty("是否分页")
	private Integer ifPage;
	@ApiModelProperty("是否合计")
	private Integer ifTotal;
	@ApiModelProperty("合计数据展示位置 1-数据下方 2 报表上方")
	private Integer totalShowType;
	@ApiModelProperty("查询条件KPI")
	private List<SaveRportKpiDTO> queryKpis;
	@ApiModelProperty("标记KPI")
	private List<SaveRportKpiDTO> colorKpis;
	@ApiModelProperty("排序KPI")
	private List<String> orderKpis;
	@ApiModelProperty("聚合KPI")
	private List<String> groupKpis;

	@ApiModelProperty("是否需要外部传参数。1是  0否")
	private Integer ifOutsideParam;

	@ApiModelProperty("报表外部传参列表")
	private List<RelReportOutsideParamDTO> reportOutsideParams;

	@ApiModelProperty("默认排序KPI")
	private String queryDefaultSortKpi;

	@ApiModelProperty("默认排序，正序asc 倒叙desc")
	private String queryDefaultOrder;

	@ApiModelProperty("汇总KPI")
	private List<String> totalKpis;

	@ApiModelProperty("是否使用可操作聚合,1使用 0不使用")
	private Integer useOperableGroup;
	@ApiModelProperty("使用可操作聚合字段kpiId")
	private List<String> operableGroupKpis;
}
