package com.datau.rpm.dto.save;

import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @ClassName: SaveTwoDTO
 * @Description:报表配置保存模板
 * @author: Zhao You Kai
 * @date: Mar 8, 2019 3:06:54 PM
 */
@Data
public class SaveTwoDTO {
	@ApiModelProperty("报表ID")
	private String id;
	@ApiModelProperty("最近更新时间")
	private String updateTime;
	@ApiModelProperty("最近更新用户ID")
	private String updateUserId;
	@ApiModelProperty("启用状态：0-停用 1-启用 ")
	private Integer status;
	private Integer colorGroupId;
	@ApiModelProperty("当前步骤：1-基本信息配置 2-选择KPI 3-查询条件配置 4-报表关系配置 5-图表配置 6-效果预览")
	private Integer currentStep;
	@ApiModelProperty("是否完成")
	private Integer ifFinish;

	@ApiModelProperty("已选KPI")
	private List<SaveRportKpiDTO> kpis;

	@ApiModelProperty("图表DML语句")
	private String DML;
	@ApiModelProperty("数据库id")
	private String databaseId;
	@ApiModelProperty("数据表id")
	private String tableId;

}
