package com.datau.rpm.util;

import java.util.List;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.datau.rpm.dto.kpim.KpiConfigDTO;
import com.datau.rpm.dto.kpim.KpiConfigForListDTO;
import com.datau.rpm.dto.kpim.TopicZtreeDTO;

/**
 * 
 * @ClassName: KpimApi
 * @Description:kpi服务提供接口
 * @author: Zhao You Kai
 * @date: Mar 6, 2019 10:35:42 AM
 */
//@FeignClient(name = "KpimApi",url = "http://localhost:9291")
@FeignClient(value = "kpim")
public interface KpimApi {
	// 查询主题树(Ztree格式带检索
	@GetMapping("/kpim/topic/topicForZtree")
	public R<List<TopicZtreeDTO>> topicForZtree(@RequestParam("name") String name);

	// 根据主题查询KPI列表
	@GetMapping("/kpim/kpiConfig/listKpiConfigsByTopic")
	public R<List<KpiConfigForListDTO>> listKpiConfigsByTopic(@RequestParam("topicId") String topicId);

	@GetMapping("/kpim/kpiConfig/listKpiConfigByKpiIds")
	public List<KpiConfigDTO> listKpiConfigByKpiIds(@RequestParam("ids") List<String> ids);
	
}
